        clc;
        clear;
        [~,~,data]=xlsread('DATA');
        smap=xlsread('smap');
        save('data');save('smap');
        % dates of the entire time series
        dates=datevec(datenum(['01-Jan-',num2str(1980)]):datenum(['31-Dec-',num2str(1990)]));
        
        dates_s=datevec(data(2:end,1));
        dates_d=dates_s(:,1:3);
        dates_day=dates_d(:,1)*100+dates_d(:,2);
        dates_month=unique(dates_day);
        % Daily data
        P=cell2mat(data(2:end,2));
        PE=cell2mat(data(2:end,3));
        Q=cell2mat(data(2:end,4));
            IND=cell(length(dates_month),1);
        for i=1:length(dates_month)
            ind=find(dates_day==dates_month(i));
            IND{i}=ind;
            clearvars i ind;
        end
        P_ex=cell(length(dates_month),1);
        PE_ex=cell(length(dates_month),1);
        Q_ex=cell(length(dates_month),1);
        for i=1:length(dates_month)
            P_ex{i}=P(IND{i});
            PE_ex{i}=PE(IND{i});
            Q_ex{i}=Q(IND{i});
            clearvars i;
        end
        data_ex=[P_ex,PE_ex,Q_ex];
        save data_ex data_ex;
        
       %% Index
        % QT 
        P_MonthSum=cellfun(@(x) sum(x),P_ex); 
        CELL_num=cellfun(@(x) length(x),P_ex);
        
        % RX1day(maximum one-day precipitation)
        P_MonthMax1=cellfun(@(x) max(x),P_ex);
        
        % RX5daymaximum five-day precipitation
        P_MonthMax5=cellfun(@(x) P_MonthMax5(x),P_ex);
        
        % R99pTOT(precipitation due to extremely wet days (> 99th percentile))
        P_Month99=cellfun(@(x) prctile(x,99),P_ex);
        
        % R95pTOT(precipitation due to very wet days (> 95th percentile))
        P_Month95=cellfun(@(x) prctile(x,95),P_ex);
        
        % R20mm(very heavy precipitation days: count of days where RR  20 mm)
        P_MonthMore20=cellfun(@(x) length(find(x>=0.02)),P_ex);        
        
        % 10mmĽR10mm(heavy precipitation days: count of days where RR (daily precipitation amount)  10 mm)
        P_MonthMore10=cellfun(@(x) length(find(x>=0.01)),P_ex);      
        
        % Rnnmm(count of days where RR  user-defined
        % threshold in mm 
        P_daysless1mmN=cellfun(@(x) P_daysless1mmN(x),P_ex);

        % PT-1
        P_MonthPre=[P_MonthSum(1);P_MonthSum(1:end-1)];

        % PE
        PE_MonthSum=cellfun(@(x) sum(x),PE_ex);
        
        % PEX1day(
        PE_MonthMax=cellfun(@(x) max(x),PE_ex);
        
        % PEN1day(
        PE_MonthMin=cellfun(@(x) min(x),PE_ex);
        
        % QT
        Q_MonthSum=cellfun(@(x) sum(x),Q_ex);
        % PT-1
        Q_MonthPre=[Q_MonthSum(1);Q_MonthSum(1:end-1)];
        

       
        indictor=[Q_MonthSum,Q_MonthPre,P_MonthSum,P_MonthMax1,P_MonthMax5,P_Month99,P_Month95,P_MonthMore20,P_MonthMore10,P_daysless1mmN,P_MonthPre,PE_MonthSum,PE_MonthMax,PE_MonthMin];
        head={'Q_MonthSum','Q_MonthPre','P_MonthSum','P_MonthMax1','P_MonthMax5','P_Month99','P_Month95','P_MonthMore20','P_MonthMore10','P_daysless1mmN','P_MonthPre','PE_MonthSum','PE_MonthMax','PE_MonthMin'};
        Indictor=[head;num2cell(indictor)];
        save Indictor Indictor;
        
        
        % Pearson_R
        P_cor=[];
        for j=1:size(indictor,2)-1
            for k=j+1:size(indictor,2)
                p1=corrcoef(indictor(:,j),indictor(:,k)); 
                p=p1(1,2);
                P_cor=[P_cor;p];
            end
   
        end
        save P P_cor
      
        R2=[];
        for j=1:size(indictor,2)-1
            for k=j+1:size(indictor,2)
                r2=rsquared(indictor(:,j),indictor(:,k),1);
                R2=[R2;r2];
            end           
        end
        save R2 R2
        
     
        a1=corrcoef(Q,P);
        A1=a1(1,2);
        Lag=20;
        A2=zeros(Lag,1);
        for i=1:Lag
            a2=corrcoef(Q,[P(1:i);P(1:end-i)]);
            A2(i)=a2(1,2);
            clearvars a2 i
        end
        
        A3=zeros(Lag,1);
        for i=1:Lag
            a3=corrcoef(Q,[Q(1:i);Q(1:end-i)]);
            A3(i)=a3(1,2);
            clearvars a3 i
        end
        
        A4=zeros(Lag,1);
        for i=1:Lag
            a4=corrcoef(Q,[PE(1:i);PE(1:end-i)]);
            A4(i)=a4(1,2);
            clearvars a4 i
        end

        