## data sets

inputs=read.table("C:/Users/Lan Tian/Desktop//03-PCA/PCA_R/Hanzhong.txt")

# Compute PCA using dudi.pca()
library("FactoMineR")
res.pca <- PCA(inputs, graph = FALSE)

# Visualization and Interpretation
# Eigenvalues / Variances(ֵ,ֵжϳѡȡɷ֣һѡȡǰPCA1 PCA2)
library("ggplot2")
library("factoextra")
eig.val <- get_eigenvalue(res.pca)
fviz_eig(res.pca, addlabels = TRUE, ylim = c(0, 80))

# Graph of variables
# results
var <- get_pca_var(res.pca)

# Correlation circle
fviz_pca_var(res.pca, col.var = "black")

# Quality of representation
library("corrplot")
corrplot(var$cos2, is.corr=FALSE)

# Total cos2 of variables on Dim.1 and Dim.2
fviz_cos2(res.pca, choice = "var", axes = 1:2)

# Color by cos2 values: quality on the factor map
fviz_pca_var(res.pca, col.var = "cos2",
             gradient.cols = c("#00AFBB", "#E7B800", "#FC4E07"), 
             repel = TRUE # Avoid text overlapping
)

# Contributions of variables to PCs
library("corrplot")
corrplot(var$contrib, is.corr=FALSE)  

# Contributions of variables to PC1
fviz_contrib(res.pca, choice = "var", axes = 1, top = 10)
# Contributions of variables to PC2
fviz_contrib(res.pca, choice = "var", axes = 2, top = 10)
# The total contribution to PC1 and PC2 is obtained
fviz_contrib(res.pca, choice = "var", axes = 1:2, top = 10)

# The most important (or, contributing) variables can be highlighted on the correlation plot
fviz_pca_var(res.pca, col.var = "contrib",
             gradient.cols = c("#00AFBB", "#E7B800", "#FC4E07")
)



