clc;
clear;
load score;
load data_ex;
Indictors=score(:,1:2);
n_clusters = 4;              % number of clusters
[center,U,obj_fcn] = fcm(Indictors,n_clusters); 
index=cell(length(n_clusters),1);
results=ones(length(Indictors),1);
for i=1:n_clusters
    index{i}=find(U(i,:)==max(U));
    results(index{i})=i;
    clearvars i;
end
save index2 index

% Based on results of FCM, hydrological processes were clustered in the
% calibraiton period.
data_cali=data_ex(1:96,:);results_cali=results(1:96);
name_cali=['P','E','Q'];
for j=1:3 %P E Q
    for k=1:2 % number of clusters
        eval([name_cali(j),'_origin',num2str(k),'=data_cali(find(results_cali==k),j)']);
        eval(['origin_cali',num2str(k),'=data_cali(find(results_cali==k),:)']);
    end
end
Origin_cali1=cell2mat(origin_cali1);
Origin_cali2=cell2mat(origin_cali2);
save Origin_cali Origin_cali1 Origin_cali2;


% Based on results of FCM, hydrological processes were clustered in the
% verification period.
data_veri=data_ex(97:end,:);results_veri=results(97:end);
name_veri=['p','e','q'];
for j=1:3 %P E Q
    for k=1:2 % number of clusters
        eval([name_veri(j),'_origin',num2str(k),'=data_veri(find(results_veri==k),j)']);
        eval(['origin_veri',num2str(k),'=data_veri(find(results_veri==k),:)']);
    end
end
Origin_veri1=cell2mat(origin_veri1);
Origin_veri2=cell2mat(origin_veri2);
save Origin_veri Origin_veri1 Origin_veri2;



data_ex1=[data_ex(1,:),;data_ex];
for m=1:3
    for r=1:length(data_ex1)-1
       eval('data_ex2{r,m}=[data_ex1{r,m};data_ex1{r+1,m}]');
    end
end
save data_ex2 data_ex2

Loca=cellfun(@(x,y) [length(x)-length(y)+1,length(x)],data_ex2(:,3),data_ex(:,3),'UniformOutput', false);
Loca_cali=Loca(1:96);
loca=cell2mat(Loca);
loca_cali=loca(1:96,:);loca_veri=loca(97:end,:);


data_ex_cali=data_ex(1:96,:);data_ex2_cali=data_ex2(1:96,:); results_cali=results(1:96);
name_cali=['P','E','Q'];
for j=1:3 %P E Q
    for k=1:2 % number of clusters
        eval([name_cali(j),num2str(k),'=data_ex_cali(find(results_cali==k),j)']);
        eval(['F_cali',num2str(k),'=data_ex_cali(find(results_cali==k),:)']);
        eval(['F_exp_cali',num2str(k),'=data_ex2_cali(find(results_cali==k),:)']);
        eval(['loca_cali',num2str(k),'=loca_cali(find(results_cali==k),:)']);
    end
end
save F_exp_cali F_exp_cali1 F_exp_cali2;
save loca_cali loca_cali1 loca_cali2;


data_ex_veri=data_ex(97:end,:); data_ex2_veri=data_ex2(97:end,:); results_veri=results(97:end);
name_veri=['p','e','q'];
for j=1:3 %P E Q
    for k=1:2 % number of clusters
        eval([name_veri(j),num2str(k),'=data_ex_veri(find(results_veri==k),j)']);
        eval(['F_veri',num2str(k),'=data_ex_veri(find(results_veri==k),:)']);
        eval(['F_exp_veri',num2str(k),'=data_ex2_veri(find(results_veri==k),:)']);
        eval(['loca_veri',num2str(k),'=loca_veri(find(results_veri==k),:)']);
    end
end
save F_exp_veri F_exp_veri1 F_exp_veri2;
save loca_veri loca_veri1 loca_veri2;

