clc;clear;close;
clearvars -global;

%---generate the date
    Date.dates=datevec(datenum(['01-Jan-',num2str(1980)]):datenum(['31-Dec-',num2str(1990)]));
    Date.year=Date.dates(:,1);
    Date.Uyear=unique(Date.year);
    Date.month=Date.dates(:,1)*100+Date.dates(:,2);  
    Date.Umonth=unique(Date.month);
    Date.halfmonth=zeros(length(Date.dates),1);
    for i=1:length(Date.Umonth)
        ind=find(Date.month==Date.Umonth(i));
        Date.halfmonth(ind(1:round(length(ind)./2)))=Date.dates(ind(1:round(length(ind)./2)),1).*1000+Date.dates(ind(1:round(length(ind)./2)),2).*10+1;  
        Date.halfmonth(ind(round(length(ind)./2)+1:end))=Date.dates(ind(round(length(ind)./2)+1:end),1).*1000+Date.dates(ind(round(length(ind)./2)+1:end),2).*10+2;
        clear i ind
    end
    Date.Uhalfmonth=unique(Date.halfmonth);
    Date.day=Date.dates(:,1).*10000+Date.dates(:,2).*100+Date.dates(:,3);
    Date.Uday=unique(Date.day);    

%---Index of  halfmonth, month and year
    Timescales={'day','halfmonth','month','year'};
    Elements={'P','PE','Q'};
    for i=1:length(Timescales)    
        name0=['Index.',Timescales{i}];
        name1=['Date.',Timescales{i}];
        name=['Date.U',Timescales{i}];
        
        eval(['Index.',Timescales{i},'=cell(length(',name,'),1);']);    
        for j=eval(['1:length(',name,')'])
            eval([name0,'{j}=find(',name1,'==',name,'(j));']);
            clear j
        end
        clear i name
    end
    clear name0 name1 Timescales Elements

%---Generating input
%     DATA = xlsread('DATA','Hanzhong').*1000;
    DATA = xlsread('DATA','Mumahe').*1000;
%     DATA = xlsread('DATA','Xunhe').*1000;
    input.data.precip   = DATA(:,1);               % Mean areal precipitation (mm)
    input.data.evap     = DATA(:,2);               % Climatic potential evaporation (mm)
    input.data.flow     = DATA(:,3);               % Streamflow discharge (mm)
    input.date.nDays    = length(input.data.flow);
    input.date.year     = Date.year(1:input.date.nDays);
    input.date.day      = Date.day(1:input.date.nDays);   
    save input input
   
%---Data for calibration
    global hymod
    hymod.data.precip   = DATA(:,1);               % Mean areal precipitation (mm)
    hymod.data.evap     = DATA(:,2);               % Climatic potential evaporation (mm)
    hymod.data.flow     = DATA(:,3);               % Streamflow discharge (mm)
    hymod.date.nDays    = length(hymod.data.flow);
    hymod.date.year     = Date.year(1:hymod.date.nDays);
    hymod.date.day      = Date.day(1:hymod.date.nDays);
    clear input DATA
    
%---Sub-period
    FCM.n_clusters = 4;   
%     FCM.clusters_halfmonths = [{[1,2,3,4,5,6,7,20,21,22,23,24]};{[8,9,10,11,12]};{[13,14,15,16,17]};{[18,19]}];  % Hanzhong
    FCM.clusters_halfmonths = [{[1,2,3,4,5,23,24]};{[6,7,8]};{[9,10,11,12,13,14,15,16,17,18]};{[19,20,21,22]}];  % Mumahe
%     FCM.clusters_halfmonths = [{[1,2,3,4,5,21,22,23,24]};{[6,7,8,9,10,11,12]};{[13,14,15,16,17]};{[18,19,20]}];  % Xunhe    
    
%---ID set for whole period
    ID=cell(FCM.n_clusters+1,1);
    % Whole period
    ID{1,1}= cell2mat(Index.year);    
    % Sub_period
    for i=1:FCM.n_clusters
        halfmonth0 = reshape(Index.halfmonth,24,[]);
        eval(['halfmonth1 = halfmonth0(FCM.clusters_halfmonths{',num2str(i),'},:);']);                
        halfmonth2 = reshape(halfmonth1,[],1);
        eval(['ID(',num2str(i),'+1) = {cell2mat(halfmonth2)};']);          
    end
    hymod.date.ID=ID;
    clear i halfmonth0 halfmonth1 halfmonth1 halfmonth2 ID  num_cali num_veri   
    
%---ID set for calibration
    ID=cell(FCM.n_clusters+1,1);
    % Whole period
    ID{1,1}= cell2mat(Index.year(2:8));    
    % Sub_period
    for i=1:FCM.n_clusters
        halfmonth0 = reshape(Index.halfmonth,24,[]);
        eval(['halfmonth1 = halfmonth0(FCM.clusters_halfmonths{',num2str(i),'},2:8);']);                
        halfmonth2 = reshape(halfmonth1,[],1);
        eval(['ID(',num2str(i),'+1) = {cell2mat(halfmonth2)};']);          
    end
    hymod.date.ID_cali=ID;
    clear i halfmonth0 halfmonth1 halfmonth1 halfmonth2 ID  num_cali num_veri   
    
%---ID set for verification
    ID=cell(FCM.n_clusters+1,1);
    % Whole period
    ID{1,1}= cell2mat(Index.year(9:11));    
    % Sub_period
    for i=1:FCM.n_clusters
        halfmonth0 = reshape(Index.halfmonth,24,[]);
        eval(['halfmonth1 = halfmonth0(FCM.clusters_halfmonths{',num2str(i),'},9:11);']);                
        halfmonth2 = reshape(halfmonth1,[],1);
        eval(['ID(',num2str(i),'+1) = {cell2mat(halfmonth2)};']);          
    end
    hymod.date.ID_veri=ID;
    clear i halfmonth0 halfmonth1 halfmonth1 halfmonth2 ID  num_cali num_veri   
    
    save Index Index
    save FCM FCM
    save Date